#pragma rtGlobals=3		// Use modern global access method and strict wave access.

Function prune(swc,spacing)
	
	wave swc				// original SWC file
	variable spacing 		// spacing of points that you would like to achieve
	
	secateurs(swc, spacing)
	
	regraft()


end


function secateurs(swc,spacing)
		
	wave swc
	variable spacing 		// spacing of points that you would like to achieve
	variable points=dimsize(swc,0)
	
	////// find the number of branches, inlucdes axon and soma
	duplicate/FREE/R=[][6] swc, paren, parx //find branches
	redimension/n=-1 paren, parx
	parx=x
	paren-=parx
	WavethreshLoc(paren,-0.000001)
	wave thresLoc   			// find branch points
	wave Bnodes = thresLoc					// find branch points
	variable ll=dimsize(thresloc,0)
	insertpoints/M=0 ll,1, thresLoc	
	thresloc[ll]=points
	////// find the number of branches
	
	variable i, bl		// index and number of branch nodes
	bl=dimsize(thresloc,0)

	// wave to hold the points to delete
	make/o/n=(points) del
	
	variable  par,rad,xx,yy,zz,px,py,pz,pr, dist, calc,totl,	bps	, j	// counter, parent,radius, x, y, z, parents xyz and radius, distance
	for(i=0;i<bl;i+=1)		// loop for going through branches
		
		bps=(bnodes[i+1]-1)-bnodes[i]
		for(j=1;j<bps;j+=1)
			if(j==1)
				par=swc[bnodes[i]][6]
				par-=1
				px=swc[par][2]
				py=swc[par][3]
				pz=swc[par][4]	//gets xyz of parent branch
			endif
			
			xx=swc[bnodes[i]+j][2]
			yy=swc[bnodes[i]+j][3]			
			zz=swc[bnodes[i]+j][4]	//gets xyz of next point
			
			
			dist=SQRT(((xx-px)^2)+((yy-py)^2)+((zz-pz)^2))
			
			
						
			if(dist>spacing)		//set the point spacing
				dist=0
				
				px=swc[bnodes[i]+j][2]
				py=swc[bnodes[i]+j][3]
				pz=swc[bnodes[i]+j][4]	//gets xyz of new permanent point
			else
				del[bnodes[i]+j]=1			
			endif 
		
		endfor
		del[bnodes[i+1]-1]=0		// make sure to keep the ned point even if it is not spaced enough
	endfor
	
	// check this section, pasted in from old code
	
	findlevels/Q/EDGE=1/DEST=st del, 1
	findlevels/Q/EDGE=2/DEST=en del, 0.000000001
		
	duplicate/o swc, temp
	
	variable l=dimsize(st,0)
	
	variable SP, EP 
	
	for(i=0;i<l;i+=1)
		
		SP=swc[st[i]][6]				
		EP=swc[en[i]][6]
		
		duplicate/FREE/R=[st[i],en[i]][5] swc, radius
		wavestats/q radius
		
		temp[en[i]][6]=SP		//connect the new point to the old parent
		temp[en[i]][5]=V_avg		// average the radii
		
	endfor
	
	del-=1
	del*=-1
	
	clean()
	
	killwaves del,st,en,thresloc
end



function WavethreshLoc(wav,thr)
	// gives the point locations of any value exceeding the threshold
	wave wav
	variable thr
	
	variable i,l
	l=dimsize(wav,0)
	make/FREE/n=(l) temp
	if(thr>0)
		for(i=0;i<l;i+=1)
			if(wav[i]>thr)
				temp[i]=i
			else
				temp[i]=nan
			endif
		endfor
	elseif(thr<0)
		for(i=0;i<l;i+=1)
			if(wav[i]<thr)
				temp[i]=i
			else
				temp[i]=nan
			endif
		endfor
	endif
	
	wavetransform zapnans temp
	
	duplicate/o temp, thresLoc
	
end


function clean()

	wave temp, del,swc
	
	temp[][]/=del[p]

	duplicate/o/R=[][0] temp, a1
	duplicate/o/R=[][1] temp, b1
	duplicate/o/R=[][2] temp, c1
	duplicate/o/R=[][3] temp, d1
	duplicate/o/R=[][4] temp, e1
	duplicate/o/R=[][5] temp, f1
	duplicate/o/R=[][6] temp, g1
		
	redimension/n=-1 a1,b1,c1,d1,e1,f1,g1
	
	
	wavetransform zapinfs a1
	wavetransform zapinfs b1
	wavetransform zapinfs c1
	wavetransform zapinfs d1
	wavetransform zapinfs e1
	wavetransform zapinfs f1
	wavetransform zapinfs g1
	
	wavetransform zapnans a1
	wavetransform zapnans b1
	wavetransform zapnans c1
	wavetransform zapnans d1
	wavetransform zapnans e1
	wavetransform zapnans f1
	wavetransform zapnans g1

	
	concatenate/NP=2/o {a1,b1,c1,d1,e1,f1,g1}, pruned 

	duplicate/o/R=[][2] pruned, tx
	duplicate/o/R=[][3] pruned, ty

	duplicate/o/R=[][2] swc, sx
	duplicate/o/R=[][3] swc, sy

	display/W=(35,44,835,744)/k=1 sy vs sx
	appendtograph ty vs tx
	ModifyGraph mode=3,marker(sy)=19,msize(sy)=1
	ModifyGraph marker(ty)=19,msize(ty)=1.5
	ModifyGraph rgb(ty)=(0,0,0)
	Label left "m";DelayUpdate
	Label bottom "m"
	Legend/C/N=text0/J/F=0/A=RT "\\s(sy) z project of original SWC\r\\s(ty) z project of resampled SWC"
	
	killwaves a1,b1,c1,d1,e1,f1,g1, temp

end



function regraft()
	// regraft branches whose parents points were pruned
	// and re-index points 
	wave pruned
	
	duplicate/o/R=[][0] pruned, roots
	duplicate/o/R=[][6] pruned, branch
	
	redimension/N=-1 roots, branch
	
	variable l=dimsize(roots,0)
	
	variable i, j,k
	j=0
	k=0
	for(i=1;i<l;i+=1)
	
		findvalue/V=(branch[i])/T=0 roots		// check if the branch point is connected to a parent
		
		if (V_value==-1)						// if not connect it to the closest one that it used to be connected to
			duplicate/o/FREE roots, temp
			temp-=branch[i]
			temp=temp^2
			temp=sqrt(temp)
			
			
			// don't conenct to self
			
			findvalue/V=0/T=0 temp
			
			duplicate/FREE roots, anybutme 
		
			deletepoints V_value,1, anybutme, temp	

			
			wavestats/q temp
			pruned[i][6]=anybutme[V_minRowLoc]
			j+=1
		endif
	
	
	endfor
	print k
	
	duplicate/FREE/R=[][0] pruned, place, index
	duplicate/FREE/R=[][6] pruned parents
	redimension/n=-1 index, parents,place
	index=x+1

	for(i=1;i<l;i+=1)

		findvalue/V=(parents[i]) place
		//print V_value
		parents[i]=index[V_value]
		
	endfor
	
	pruned[][0]=index[p]
	pruned[][6]=parents[p]
	print "Found and repaired "+num2str(j)+" faulty branch points"
	killwaves roots, branch
end

